#include <stdio.h>

#include "test/assert.h"
#include "test/attribute/ACDelegate.h"

#define NB_ATTR 5

typedef struct
{
  const int a;
  const char *s;
  const char c;
  short i;
  void *p;
} attributes_t;

attributes_t myAttributes = { 10, "foo", 'c', 5, NULL };

typedef struct
{
  unsigned int nbAttribute;
  struct AttributeDesc_t attributes[5];
  unsigned int nbConstAttribute;
  const char* const_attribute_names[2];
} ACData_t;

ACData_t attributes_desc = { NB_ATTR, { { "a", (void **) &(myAttributes.a),
    sizeof(int) }, { "s", (void **) &(myAttributes.s), sizeof(char *) }, { "c",
    (void **) &(myAttributes.c), sizeof(char) }, { "i",
    (void **) &(myAttributes.i), sizeof(short) }, { "p",
    (void **) &(myAttributes.p), sizeof(void *) } },
    2,
    { "a", "c"}
};

void test_setFcAttribute()
{
  int e;

  e = CALL_AC(setFcAttribute, &attributes_desc, "a", (void *) 5);
  /* assert that a constant field can't be set */
  ASSERT_EQUALS_INT("test_getFcAttribute: setFcAttribute(a, 5) return value",
      fractal_api_AttributeController_OPERATION_NOT_SUPPORTED, e);
  /* assert the value is still the original one */
  ASSERT_EQUALS_INT("value of a", 10, myAttributes.a);

  e = CALL_AC(setFcAttribute, &attributes_desc, "c", (void *) 'd');
  /* assert that a constant field can't be set */
  ASSERT_EQUALS_INT("test_getFcAttribute: setFcAttribute(c, 'd') return value",
	fractal_api_AttributeController_OPERATION_NOT_SUPPORTED, e);
  /* assert the value is still the original one */
  ASSERT_EQUALS_INT("value of c", 'c', myAttributes.c);
}

int main()
{
  test_setFcAttribute();

  return 0;
}
