/**
 * Cecilia, an implementation of the Fractal component model in C.
 * Copyright (C) 2006 STMicroelectronics
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Matthieu Leclercq
 */
#include <string.h>

DECLARE_DATA {
  int started;
  int ok;
};

#include <cecilia.h>

jint METHOD(r, run)(void *_this) {
  return DATA.ok;
}

// -----------------------------------------------------------------------------
// Implementation of the lifecycle-controller interface.
// -----------------------------------------------------------------------------

// int getFcState();
int METHOD(lifecycle_controller, getFcState) (void* _this) {
  if (DATA.started != 1)
    return fractal_api_LifeCycleController_STOPPED;
  else
    return fractal_api_LifeCycleController_STARTED;
}

// int startFc();
int METHOD(lifecycle_controller, startFc) (void* _this) {
  
  // call client interface
  DATA.ok = CALL(REQUIRED.c, run);
  
  DATA.started = 1;
  return fractal_api_ErrorConst_OK;
}

// int stopFc();
int METHOD(lifecycle_controller, stopFc) (void* _this) {
  DATA.started = 0;
  return fractal_api_ErrorConst_OK;
}
